Index: uspace/srv/bd/ata_bd/ata_hw.h
===================================================================
--- uspace/srv/bd/ata_bd/ata_hw.h	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/bd/ata_bd/ata_hw.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -293,12 +293,4 @@
 };
 
-enum ata_pdev_signature {
-	/**
-	 * Signature put by a packet device in byte count register
-	 * in response to Identify command.
-	 */
-	PDEV_SIGNATURE_BC	= 0xEB14
-};
-
 #endif
 
Index: uspace/srv/devman/devman.c
===================================================================
--- uspace/srv/devman/devman.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/devman/devman.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -34,5 +34,4 @@
 #include <fcntl.h>
 #include <sys/stat.h>
-#include <io/log.h>
 #include <ipc/driver.h>
 #include <ipc/devman.h>
@@ -147,6 +146,6 @@
 	fibril_mutex_unlock(&drivers_list->drivers_mutex);
 
-	log_msg(LVL_NOTE, "Driver `%s' was added to the list of available "
-	    "drivers.", drv->name);
+	printf(NAME": the '%s' driver was added to the list of available "
+	    "drivers.\n", drv->name);
 }
 
@@ -238,5 +237,5 @@
 bool read_match_ids(const char *conf_path, match_id_list_t *ids)
 {
-	log_msg(LVL_DEBUG, "read_match_ids(conf_path=\"%s\")", conf_path);
+	printf(NAME ": read_match_ids conf_path = %s.\n", conf_path);
 	
 	bool suc = false;
@@ -248,6 +247,5 @@
 	fd = open(conf_path, O_RDONLY);
 	if (fd < 0) {
-		log_msg(LVL_ERROR, "Unable to open `%s' for reading: %s.",
-		    conf_path, str_error(fd));
+		printf(NAME ": unable to open %s\n", conf_path);
 		goto cleanup;
 	}
@@ -257,6 +255,5 @@
 	lseek(fd, 0, SEEK_SET);
 	if (len == 0) {
-		log_msg(LVL_ERROR, "Configuration file '%s' is empty.",
-		    conf_path);
+		printf(NAME ": configuration file '%s' is empty.\n", conf_path);
 		goto cleanup;
 	}
@@ -264,15 +261,14 @@
 	buf = malloc(len + 1);
 	if (buf == NULL) {
-		log_msg(LVL_ERROR, "Memory allocation failed when parsing file "
-		    "'%s'.", conf_path);
+		printf(NAME ": memory allocation failed when parsing file "
+		    "'%s'.\n", conf_path);
 		goto cleanup;
 	}
 	
-	ssize_t read_bytes = safe_read(fd, buf, len);
-	if (read_bytes <= 0) {
-		log_msg(LVL_ERROR, "Unable to read file '%s'.", conf_path);
+	if (read(fd, buf, len) <= 0) {
+		printf(NAME ": unable to read file '%s'.\n", conf_path);
 		goto cleanup;
 	}
-	buf[read_bytes] = 0;
+	buf[len] = 0;
 	
 	suc = parse_match_ids(buf, ids);
@@ -309,5 +305,5 @@
 bool get_driver_info(const char *base_path, const char *name, driver_t *drv)
 {
-	log_msg(LVL_DEBUG, "get_driver_info(base_path=\"%s\", name=\"%s\")",
+	printf(NAME ": get_driver_info base_path = %s, name = %s.\n",
 	    base_path, name);
 	
@@ -341,6 +337,5 @@
 	struct stat s;
 	if (stat(drv->binary_path, &s) == ENOENT) { /* FIXME!! */
-		log_msg(LVL_ERROR, "Driver not found at path `%s'.",
-		    drv->binary_path);
+		printf(NAME ": driver not found at path %s.", drv->binary_path);
 		goto cleanup;
 	}
@@ -369,5 +364,5 @@
 int lookup_available_drivers(driver_list_t *drivers_list, const char *dir_path)
 {
-	log_msg(LVL_DEBUG, "lookup_available_drivers(dir=\"%s\")", dir_path);
+	printf(NAME ": lookup_available_drivers, dir = %s \n", dir_path);
 	
 	int drv_cnt = 0;
@@ -403,5 +398,5 @@
 	dev_node_t *dev;
 	
-	log_msg(LVL_DEBUG, "create_root_nodes()");
+	printf(NAME ": create_root_nodes\n");
 	
 	fibril_rwlock_write_lock(&tree->rwlock);
@@ -488,6 +483,6 @@
 void attach_driver(dev_node_t *dev, driver_t *drv)
 {
-	log_msg(LVL_DEBUG, "attach_driver(dev=\"%s\",drv=\"%s\")",
-	    dev->pfun->pathname, drv->name);
+	printf(NAME ": attach_driver %s to device %s\n",
+	    drv->name, dev->pfun->pathname);
 	
 	fibril_mutex_lock(&drv->driver_mutex);
@@ -511,10 +506,10 @@
 	assert(fibril_mutex_is_locked(&drv->driver_mutex));
 	
-	log_msg(LVL_DEBUG, "start_driver(drv=\"%s\")", drv->name);
+	printf(NAME ": start_driver '%s'\n", drv->name);
 	
 	rc = task_spawnl(NULL, drv->binary_path, drv->binary_path, NULL);
 	if (rc != EOK) {
-		log_msg(LVL_ERROR, "Spawning driver `%s' (%s) failed: %s.",
-		    drv->name, drv->binary_path, str_error(rc));
+		printf(NAME ": error spawning %s (%s)\n",
+		    drv->name, str_error(rc));
 		return false;
 	}
@@ -578,6 +573,5 @@
 	int phone;
 
-	log_msg(LVL_DEBUG, "pass_devices_to_driver(driver=\"%s\")",
-	    driver->name);
+	printf(NAME ": pass_devices_to_driver(`%s')\n", driver->name);
 
 	fibril_mutex_lock(&driver->driver_mutex);
@@ -646,5 +640,5 @@
 	 * immediately and possibly started here as well.
 	 */
-	log_msg(LVL_DEBUG, "Driver `%s' enters running state.", driver->name);
+	printf(NAME ": driver %s goes into running state.\n", driver->name);
 	driver->state = DRIVER_RUNNING;
 
@@ -663,6 +657,5 @@
 void initialize_running_driver(driver_t *driver, dev_tree_t *tree)
 {
-	log_msg(LVL_DEBUG, "initialize_running_driver(driver=\"%s\")",
-	    driver->name);
+	printf(NAME ": initialize_running_driver (`%s')\n", driver->name);
 	
 	/*
@@ -754,6 +747,6 @@
 	 * access any structures that would affect driver_t.
 	 */
-	log_msg(LVL_DEBUG, "add_device(drv=\"%s\", dev=\"%s\")",
-	    drv->name, dev->pfun->name);
+	printf(NAME ": add_device (driver `%s', device `%s')\n", drv->name,
+	    dev->pfun->name);
 	
 	sysarg_t rc;
@@ -816,5 +809,5 @@
 	driver_t *drv = find_best_match_driver(drivers_list, dev);
 	if (drv == NULL) {
-		log_msg(LVL_ERROR, "No driver found for device `%s'.",
+		printf(NAME ": no driver found for device '%s'.\n",
 		    dev->pfun->pathname);
 		return false;
@@ -854,5 +847,5 @@
 bool init_device_tree(dev_tree_t *tree, driver_list_t *drivers_list)
 {
-	log_msg(LVL_DEBUG, "init_device_tree()");
+	printf(NAME ": init_device_tree.\n");
 	
 	tree->current_handle = 0;
@@ -1033,5 +1026,5 @@
 	fun->pathname = (char *) malloc(pathsize);
 	if (fun->pathname == NULL) {
-		log_msg(LVL_ERROR, "Failed to allocate device path.");
+		printf(NAME ": failed to allocate device path.\n");
 		return false;
 	}
@@ -1064,7 +1057,4 @@
 	assert(fibril_rwlock_is_write_locked(&tree->rwlock));
 	
-	log_msg(LVL_DEBUG, "insert_dev_node(dev=%p, pfun=%p [\"%s\"])",
-	    dev, pfun, pfun->pathname);
-
 	/* Add the node to the handle-to-node map. */
 	dev->handle = ++tree->current_handle;
@@ -1073,4 +1063,5 @@
 
 	/* Add the node to the list of its parent's children. */
+	printf("insert_dev_node: dev=%p, dev->pfun := %p\n", dev, pfun);
 	dev->pfun = pfun;
 	pfun->child = dev;
@@ -1132,11 +1123,4 @@
 fun_node_t *find_fun_node_by_path(dev_tree_t *tree, char *path)
 {
-	assert(path != NULL);
-
-	bool is_absolute = path[0] == '/';
-	if (!is_absolute) {
-		return NULL;
-	}
-
 	fibril_rwlock_read_lock(&tree->rwlock);
 	
@@ -1148,5 +1132,5 @@
 	char *rel_path = path;
 	char *next_path_elem = NULL;
-	bool cont = true;
+	bool cont = (rel_path[0] == '/');
 	
 	while (cont && fun != NULL) {
@@ -1173,63 +1157,4 @@
 }
 
-/** Find function with a specified name belonging to given device.
- *
- * Device tree rwlock should be held at least for reading.
- *
- * @param dev Device the function belongs to.
- * @param name Function name (not path).
- * @return Function node.
- * @retval NULL No function with given name.
- */
-fun_node_t *find_fun_node_in_device(dev_node_t *dev, const char *name)
-{
-	assert(dev != NULL);
-	assert(name != NULL);
-
-	fun_node_t *fun;
-	link_t *link;
-
-	for (link = dev->functions.next;
-	    link != &dev->functions;
-	    link = link->next) {
-		fun = list_get_instance(link, fun_node_t, dev_functions);
-
-		if (str_cmp(name, fun->name) == 0)
-			return fun;
-	}
-
-	return NULL;
-}
-
-/** Find function node by its class name and index. */
-fun_node_t *find_fun_node_by_class(class_list_t *class_list,
-    const char *class_name, const char *dev_name)
-{
-	assert(class_list != NULL);
-	assert(class_name != NULL);
-	assert(dev_name != NULL);
-
-	fibril_rwlock_read_lock(&class_list->rwlock);
-
-	dev_class_t *cl = find_dev_class_no_lock(class_list, class_name);
-	if (cl == NULL) {
-		fibril_rwlock_read_unlock(&class_list->rwlock);
-		return NULL;
-	}
-
-	dev_class_info_t *dev = find_dev_in_class(cl, dev_name);
-	if (dev == NULL) {
-		fibril_rwlock_read_unlock(&class_list->rwlock);
-		return NULL;
-	}
-
-	fun_node_t *fun = dev->fun;
-
-	fibril_rwlock_read_unlock(&class_list->rwlock);
-
-	return fun;
-}
-
-
 /** Find child function node with a specified name.
  *
@@ -1242,5 +1167,19 @@
 fun_node_t *find_node_child(fun_node_t *pfun, const char *name)
 {
-	return find_fun_node_in_device(pfun->child, name);
+	fun_node_t *fun;
+	link_t *link;
+	
+	link = pfun->child->functions.next;
+	
+	while (link != &pfun->child->functions) {
+		fun = list_get_instance(link, fun_node_t, dev_functions);
+		
+		if (str_cmp(name, fun->name) == 0)
+			return fun;
+		
+		link = link->next;
+	}
+	
+	return NULL;
 }
 
@@ -1404,24 +1343,4 @@
 }
 
-dev_class_info_t *find_dev_in_class(dev_class_t *dev_class, const char *dev_name)
-{
-	assert(dev_class != NULL);
-	assert(dev_name != NULL);
-
-	link_t *link;
-	for (link = dev_class->devices.next;
-	    link != &dev_class->devices;
-	    link = link->next) {
-		dev_class_info_t *dev = list_get_instance(link,
-		    dev_class_info_t, link);
-
-		if (str_cmp(dev->dev_name, dev_name) == 0) {
-			return dev;
-		}
-	}
-
-	return NULL;
-}
-
 void init_class_list(class_list_t *class_list)
 {
Index: uspace/srv/devman/devman.h
===================================================================
--- uspace/srv/devman/devman.h	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/devman/devman.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -338,6 +338,4 @@
 extern fun_node_t *find_fun_node(dev_tree_t *tree, devman_handle_t handle);
 extern fun_node_t *find_fun_node_by_path(dev_tree_t *, char *);
-extern fun_node_t *find_fun_node_in_device(dev_node_t *, const char *);
-extern fun_node_t *find_fun_node_by_class(class_list_t *, const char *, const char *);
 
 /* Device tree */
@@ -361,5 +359,4 @@
 extern dev_class_t *get_dev_class(class_list_t *, char *);
 extern dev_class_t *find_dev_class_no_lock(class_list_t *, const char *);
-extern dev_class_info_t *find_dev_in_class(dev_class_t *, const char *);
 extern void add_dev_class_no_lock(class_list_t *, dev_class_t *);
 
Index: uspace/srv/devman/main.c
===================================================================
--- uspace/srv/devman/main.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/devman/main.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -43,5 +43,4 @@
 #include <stdio.h>
 #include <errno.h>
-#include <str_error.h>
 #include <bool.h>
 #include <fibril_synch.h>
@@ -52,5 +51,4 @@
 #include <sys/stat.h>
 #include <ctype.h>
-#include <io/log.h>
 #include <ipc/devman.h>
 #include <ipc/driver.h>
@@ -73,5 +71,5 @@
 	driver_t *driver = NULL;
 
-	log_msg(LVL_DEBUG, "devman_driver_register");
+	printf(NAME ": devman_driver_register \n");
 	
 	iid = async_get_call(&icall);
@@ -90,5 +88,5 @@
 	}
 
-	log_msg(LVL_DEBUG, "The `%s' driver is trying to register.",
+	printf(NAME ": the %s driver is trying to register by the service.\n",
 	    drv_name);
 	
@@ -97,5 +95,5 @@
 	
 	if (driver == NULL) {
-		log_msg(LVL_ERROR, "No driver named `%s' was found.", drv_name);
+		printf(NAME ": no driver named %s was found.\n", drv_name);
 		free(drv_name);
 		drv_name = NULL;
@@ -108,6 +106,5 @@
 	
 	/* Create connection to the driver. */
-	log_msg(LVL_DEBUG, "Creating connection to the `%s' driver.",
-	    driver->name);
+	printf(NAME ":  creating connection to the %s driver.\n", driver->name);
 	ipc_call_t call;
 	ipc_callid_t callid = async_get_call(&call);
@@ -121,6 +118,5 @@
 	set_driver_phone(driver, IPC_GET_ARG5(call));
 	
-	log_msg(LVL_NOTE, 
-	    "The `%s' driver was successfully registered as running.",
+	printf(NAME ": the %s driver was successfully registered as running.\n",
 	    driver->name);
 	
@@ -146,6 +142,6 @@
 	callid = async_get_call(&call);
 	if (DEVMAN_ADD_MATCH_ID != IPC_GET_IMETHOD(call)) {
-		log_msg(LVL_ERROR, 
-		    "Invalid protocol when trying to receive match id.");
+		printf(NAME ": ERROR: devman_receive_match_id - invalid "
+		    "protocol.\n");
 		async_answer_0(callid, EINVAL); 
 		delete_match_id(match_id);
@@ -154,5 +150,6 @@
 	
 	if (match_id == NULL) {
-		log_msg(LVL_ERROR, "Failed to allocate match id.");
+		printf(NAME ": ERROR: devman_receive_match_id - failed to "
+		    "allocate match id.\n");
 		async_answer_0(callid, ENOMEM);
 		return ENOMEM;
@@ -168,6 +165,6 @@
 	if (rc != EOK) {
 		delete_match_id(match_id);
-		log_msg(LVL_ERROR, "Failed to receive match id string: %s.",
-		    str_error(rc));
+		printf(NAME ": devman_receive_match_id - failed to receive "
+		    "match id string.\n");
 		return rc;
 	}
@@ -175,5 +172,5 @@
 	list_append(&match_id->link, &match_ids->ids);
 	
-	log_msg(LVL_DEBUG, "Received match id `%s', score %d.",
+	printf(NAME ": received match id '%s', score = %d \n",
 	    match_id->id, match_id->score);
 	return rc;
@@ -231,7 +228,5 @@
 	if (ftype != fun_inner && ftype != fun_exposed) {
 		/* Unknown function type */
-		log_msg(LVL_ERROR, 
-		    "Unknown function type %d provided by driver.",
-		    (int) ftype);
+		printf(NAME ": Error, unknown function type provided by driver!\n");
 
 		fibril_rwlock_write_unlock(&tree->rwlock);
@@ -248,14 +243,4 @@
 	}
 	
-	/* Check that function with same name is not there already. */
-	if (find_fun_node_in_device(pdev, fun_name) != NULL) {
-		fibril_rwlock_write_unlock(&tree->rwlock);
-		async_answer_0(callid, EEXISTS);
-		printf(NAME ": Warning, driver tried to register `%s' twice.\n",
-		    fun_name);
-		free(fun_name);
-		return;
-	}
-
 	fun_node_t *fun = create_fun_node();
 	if (!insert_fun_node(&device_tree, fun, fun_name, pdev)) {
@@ -280,5 +265,5 @@
 	fibril_rwlock_write_unlock(&tree->rwlock);
 	
-	log_msg(LVL_DEBUG, "devman_add_function(fun=\"%s\")", fun->pathname);
+	printf(NAME ": devman_add_function %s\n", fun->pathname);
 	
 	devman_receive_match_ids(match_count, &fun->match_ids);
@@ -362,6 +347,6 @@
 	devmap_register_class_dev(class_info);
 	
-	log_msg(LVL_NOTE, "Function `%s' added to class `%s' as `%s'.",
-	    fun->pathname, class_name, class_info->dev_name);
+	printf(NAME ": function'%s' added to class '%s', class name '%s' was "
+	    "asigned to it\n", fun->pathname, class_name, class_info->dev_name);
 
 	async_answer_0(callid, EOK);
@@ -378,5 +363,5 @@
 	
 	initialize_running_driver(driver, &device_tree);
-	log_msg(LVL_DEBUG, "The `%s` driver was successfully initialized.",
+	printf(NAME ": the %s driver was successfully initialized. \n",
 	    driver->name);
 	return 0;
@@ -400,6 +385,6 @@
 	fid_t fid = fibril_create(init_running_drv, driver);
 	if (fid == 0) {
-		log_msg(LVL_ERROR, "Failed to create initialization fibril " \
-		    "for driver `%s'.", driver->name);
+		printf(NAME ": Error creating fibril for the initialization of "
+		    "the newly registered running driver.\n");
 		return;
 	}
@@ -453,38 +438,4 @@
 }
 
-/** Find handle for the device instance identified by device class name. */
-static void devman_function_get_handle_by_class(ipc_callid_t iid,
-    ipc_call_t *icall)
-{
-	char *classname;
-	char *devname;
-
-	int rc = async_data_write_accept((void **) &classname, true, 0, 0, 0, 0);
-	if (rc != EOK) {
-		async_answer_0(iid, rc);
-		return;
-	}
-	rc = async_data_write_accept((void **) &devname, true, 0, 0, 0, 0);
-	if (rc != EOK) {
-		free(classname);
-		async_answer_0(iid, rc);
-		return;
-	}
-
-
-	fun_node_t *fun = find_fun_node_by_class(&class_list,
-	    classname, devname);
-
-	free(classname);
-	free(devname);
-
-	if (fun == NULL) {
-		async_answer_0(iid, ENOENT);
-		return;
-	}
-
-	async_answer_1(iid, EOK, fun->handle);
-}
-
 
 /** Function for handling connections from a client to the device manager. */
@@ -506,7 +457,4 @@
 			devman_function_get_handle(callid, &call);
 			break;
-		case DEVMAN_DEVICE_GET_HANDLE_BY_CLASS:
-			devman_function_get_handle_by_class(callid, &call);
-			break;
 		default:
 			async_answer_0(callid, ENOENT);
@@ -529,13 +477,7 @@
 		dev = fun->dev;
 
-	/*
-	 * For a valid function to connect to we need a device. The root
-	 * function, for example, has no device and cannot be connected to.
-	 * This means @c dev needs to be valid regardless whether we are
-	 * connecting to a device or to a function.
-	 */
-	if (dev == NULL) {
-		log_msg(LVL_ERROR, "IPC forwarding failed - no device or "
-		    "function with handle %" PRIun " was found.", handle);
+	if (fun == NULL && dev == NULL) {
+		printf(NAME ": devman_forward error - no device or function with "
+		    "handle %" PRIun " was found.\n", handle);
 		async_answer_0(iid, ENOENT);
 		return;
@@ -543,7 +485,6 @@
 
 	if (fun == NULL && !drv_to_parent) {
-		log_msg(LVL_ERROR, NAME ": devman_forward error - cannot "
-		    "connect to handle %" PRIun ", refers to a device.",
-		    handle);
+		printf(NAME ": devman_forward error - cannot connect to "
+		    "handle %" PRIun ", refers to a device.\n", handle);
 		async_answer_0(iid, ENOENT);
 		return;
@@ -566,6 +507,6 @@
 	
 	if (driver == NULL) {
-		log_msg(LVL_ERROR, "IPC forwarding refused - " \
-		    "the device %" PRIun " is not in usable state.", handle);
+		printf(NAME ": devman_forward error - the device is not in %" PRIun
+		    " usable state.\n", handle);
 		async_answer_0(iid, ENOENT);
 		return;
@@ -579,7 +520,7 @@
 	
 	if (driver->phone <= 0) {
-		log_msg(LVL_ERROR, 
-		    "Could not forward to driver `%s' (phone is %d).",
-		    driver->name, (int) driver->phone);
+		printf(NAME ": devman_forward: cound not forward to driver %s ",
+		    driver->name);
+		printf("the driver's phone is %" PRIun ").\n", driver->phone);
 		async_answer_0(iid, EINVAL);
 		return;
@@ -587,11 +528,9 @@
 
 	if (fun != NULL) {
-		log_msg(LVL_DEBUG, 
-		    "Forwarding request for `%s' function to driver `%s'.",
-		    fun->pathname, driver->name);
+		printf(NAME ": devman_forward: forward connection to function %s to "
+		    "driver %s.\n", fun->pathname, driver->name);
 	} else {
-		log_msg(LVL_DEBUG, 
-		    "Forwarding request for `%s' device to driver `%s'.",
-		    dev->pfun->pathname, driver->name);
+		printf(NAME ": devman_forward: forward connection to device %s to "
+		    "driver %s.\n", dev->pfun->pathname, driver->name);
 	}
 
@@ -625,7 +564,6 @@
 	async_forward_fast(iid, dev->drv->phone, DRIVER_CLIENT, fun->handle, 0,
 	    IPC_FF_NONE);
-	log_msg(LVL_DEBUG, 
-	    "Forwarding devmapper request for `%s' function to driver `%s'.",
-	    fun->pathname, dev->drv->name);
+	printf(NAME ": devman_connection_devmapper: forwarded connection to "
+	    "device %s to driver %s.\n", fun->pathname, dev->drv->name);
 }
 
@@ -662,5 +600,5 @@
 static bool devman_init(void)
 {
-	log_msg(LVL_DEBUG, "devman_init - looking for available drivers.");
+	printf(NAME ": devman_init - looking for available drivers.\n");
 	
 	/* Initialize list of available drivers. */
@@ -668,13 +606,13 @@
 	if (lookup_available_drivers(&drivers_list,
 	    DRIVER_DEFAULT_STORE) == 0) {
-		log_msg(LVL_FATAL, "No drivers found.");
+		printf(NAME " no drivers found.");
 		return false;
 	}
 
-	log_msg(LVL_DEBUG, "devman_init - list of drivers has been initialized.");
+	printf(NAME ": devman_init  - list of drivers has been initialized.\n");
 
 	/* Create root device node. */
 	if (!init_device_tree(&device_tree, &drivers_list)) {
-		log_msg(LVL_FATAL, "Failed to initialize device tree.");
+		printf(NAME " failed to initialize device tree.");
 		return false;
 	}
@@ -697,11 +635,6 @@
 	printf(NAME ": HelenOS Device Manager\n");
 
-	if (log_init(NAME, LVL_ERROR) != EOK) {
-		printf(NAME ": Error initializing logging subsystem.\n");
-		return -1;
-	}
-
 	if (!devman_init()) {
-		log_msg(LVL_ERROR, "Error while initializing service.");
+		printf(NAME ": Error while initializing service\n");
 		return -1;
 	}
@@ -711,10 +644,8 @@
 
 	/* Register device manager at naming service. */
-	if (service_register(SERVICE_DEVMAN) != EOK) {
-		log_msg(LVL_ERROR, "Failed registering as a service.");
+	if (service_register(SERVICE_DEVMAN) != EOK)
 		return -1;
-	}
-
-	printf(NAME ": Accepting connections.\n");
+
+	printf(NAME ": Accepting connections\n");
 	async_manager();
 
Index: uspace/srv/devman/util.c
===================================================================
--- uspace/srv/devman/util.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/devman/util.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -111,31 +111,4 @@
 }
 
-ssize_t safe_read(int fd, void *buffer, size_t size)
-{
-	if (size == 0) {
-		return 0;
-	}
-
-	uint8_t *buf_ptr = (uint8_t *) buffer;
-
-	size_t total_read = 0;
-	while (total_read < size) {
-		ssize_t bytes_read = read(fd, buf_ptr, size - total_read);
-		if (bytes_read < 0) {
-			/* Error. */
-			return bytes_read;
-		} else if (bytes_read == 0) {
-			/* Possibly end of file. */
-			break;
-		} else {
-			/* Read at least something. */
-			buf_ptr += bytes_read;
-			total_read += bytes_read;
-		}
-	}
-
-	return (ssize_t) total_read;
-}
-
 /** @}
  */
Index: uspace/srv/devman/util.h
===================================================================
--- uspace/srv/devman/util.h	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/devman/util.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -47,6 +47,4 @@
 extern void replace_char(char *, char, char);
 
-extern ssize_t safe_read(int, void *, size_t);
-
 #endif
 
Index: uspace/srv/devmap/devmap.c
===================================================================
--- uspace/srv/devmap/devmap.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/devmap/devmap.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -551,5 +551,5 @@
 	if (devmap_device_find_name(namespace->name, device->name) != NULL) {
 		printf("%s: Device '%s/%s' already registered\n", NAME,
-		    namespace->name, device->name);
+		    device->namespace->name, device->name);
 		devmap_namespace_destroy(namespace);
 		fibril_mutex_unlock(&devices_list_mutex);
Index: uspace/srv/hid/kbd/Makefile
===================================================================
--- uspace/srv/hid/kbd/Makefile	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/hid/kbd/Makefile	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -78,5 +78,5 @@
 		SOURCES += \
 			port/pl050.c \
-			ctl/pc.c
+			ctl/pl050.c
 	endif
 endif
Index: uspace/srv/hid/kbd/ctl/pl050.c
===================================================================
--- uspace/srv/hid/kbd/ctl/pl050.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
+++ uspace/srv/hid/kbd/ctl/pl050.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -0,0 +1,267 @@
+/*
+ * Copyright (c) 2009 Vineeth Pillai
+ * All rights reserved.
+ *
+ * Redistribution and use in source and binary forms, with or without
+ * modification, are permitted provided that the following conditions
+ * are met:
+ *
+ * - Redistributions of source code must retain the above copyright
+ *   notice, this list of conditions and the following disclaimer.
+ * - Redistributions in binary form must reproduce the above copyright
+ *   notice, this list of conditions and the following disclaimer in the
+ *   documentation and/or other materials provided with the distribution.
+ * - The name of the author may not be used to endorse or promote products
+ *   derived from this software without specific prior written permission.
+ *
+ * THIS SOFTWARE IS PROVIDED BY THE AUTHOR ``AS IS'' AND ANY EXPRESS OR
+ * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES
+ * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED.
+ * IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY DIRECT, INDIRECT,
+ * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT
+ * NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
+ * DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
+ * THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
+ * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF
+ * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
+ */
+
+/** @addtogroup kbd_ctl
+ * @ingroup kbd
+ * @{
+ */
+/**
+ * @file
+ * @brief PL050 keyboard controller driver.
+ */
+
+#include <kbd.h>
+#include <io/console.h>
+#include <io/keycode.h>
+#include <kbd_ctl.h>
+#include <gsp.h>
+#include <stdio.h>
+
+#define PL050_CAPS_SCAN_CODE 0x58
+#define PL050_NUM_SCAN_CODE 0x77
+#define PL050_SCROLL_SCAN_CODE 0x7E
+
+static bool is_lock_key(int);
+enum dec_state {
+	ds_s,
+	ds_e
+};
+
+static enum dec_state ds;
+
+static int scanmap_simple[] = {
+
+	[0x0e] = KC_BACKTICK,
+
+	[0x16] = KC_1,
+	[0x1e] = KC_2,
+	[0x26] = KC_3,
+	[0x25] = KC_4,
+	[0x2e] = KC_5,
+	[0x36] = KC_6,
+	[0x3d] = KC_7,
+	[0x3e] = KC_8,
+	[0x46] = KC_9,
+	[0x45] = KC_0,
+
+	[0x4e] = KC_MINUS,
+	[0x55] = KC_EQUALS,
+	[0x66] = KC_BACKSPACE,
+
+	[0x0d] = KC_TAB,
+
+	[0x15] = KC_Q,
+	[0x1d] = KC_W,
+	[0x24] = KC_E,
+	[0x2d] = KC_R,
+	[0x2c] = KC_T,
+	[0x35] = KC_Y,
+	[0x3c] = KC_U,
+	[0x43] = KC_I,
+	[0x44] = KC_O,
+	[0x4d] = KC_P,
+
+	[0x54] = KC_LBRACKET,
+	[0x5b] = KC_RBRACKET,
+
+	[0x58] = KC_CAPS_LOCK,
+
+	[0x1c] = KC_A,
+	[0x1b] = KC_S,
+	[0x23] = KC_D,
+	[0x2b] = KC_F,
+	[0x34] = KC_G,
+	[0x33] = KC_H,
+	[0x3b] = KC_J,
+	[0x42] = KC_K,
+	[0x4b] = KC_L,
+
+	[0x4c] = KC_SEMICOLON,
+	[0x52] = KC_QUOTE,
+	[0x5d] = KC_BACKSLASH,
+
+	[0x12] = KC_LSHIFT,
+
+	[0x1a] = KC_Z,
+	[0x22] = KC_X,
+	[0x21] = KC_C,
+	[0x2a] = KC_V,
+	[0x32] = KC_B,
+	[0x31] = KC_N,
+	[0x3a] = KC_M,
+
+	[0x41] = KC_COMMA,
+	[0x49] = KC_PERIOD,
+	[0x4a] = KC_SLASH,
+
+	[0x59] = KC_RSHIFT,
+
+	[0x14] = KC_LCTRL,
+	[0x11] = KC_LALT,
+	[0x29] = KC_SPACE,
+
+	[0x76] = KC_ESCAPE,
+
+	[0x05] = KC_F1,
+	[0x06] = KC_F2,
+	[0x04] = KC_F3,
+	[0x0c] = KC_F4,
+	[0x03] = KC_F5,
+	[0x0b] = KC_F6,
+	[0x02] = KC_F7,
+
+	[0x0a] = KC_F8,
+	[0x01] = KC_F9,
+	[0x09] = KC_F10,
+
+	[0x78] = KC_F11,
+	[0x07] = KC_F12,
+
+	[0x60] = KC_SCROLL_LOCK,
+
+	[0x5a] = KC_ENTER,
+
+	[0x77] = KC_NUM_LOCK,
+	[0x7c] = KC_NTIMES,
+	[0x7b] = KC_NMINUS,
+	[0x79] = KC_NPLUS,
+	[0x6c] = KC_N7,
+	[0x75] = KC_N8,
+	[0x7d] = KC_N9,
+	[0x6b] = KC_N4,
+	[0x73] = KC_N5,
+	[0x74] = KC_N6,
+	[0x69] = KC_N1,
+	[0x72] = KC_N2,
+	[0x7a] = KC_N3,
+	[0x70] = KC_N0,
+	[0x71] = KC_NPERIOD
+};
+
+static int scanmap_e0[] = {
+	[0x65] = KC_RALT,
+	[0x59] = KC_RSHIFT,
+
+	[0x64] = KC_PRTSCR,
+
+	[0x70] = KC_INSERT,
+	[0x6c] = KC_HOME,
+	[0x7d] = KC_PAGE_UP,
+
+	[0x71] = KC_DELETE,
+	[0x69] = KC_END,
+	[0x7a] = KC_PAGE_DOWN,
+
+	[0x75] = KC_UP,
+	[0x6b] = KC_LEFT,
+	[0x72] = KC_DOWN,
+	[0x74] = KC_RIGHT,
+
+	[0x4a] = KC_NSLASH,
+	[0x5a] = KC_NENTER
+};
+
+int kbd_ctl_init(void)
+{
+	ds = ds_s;
+	return 0;
+}
+
+void kbd_ctl_parse_scancode(int scancode)
+{
+	static int key_release_flag = 0;
+	static int is_locked = 0;
+	console_ev_type_t type;
+	unsigned int key;
+	int *map;
+	size_t map_length;
+
+	if (scancode == 0xe0) {
+		ds = ds_e;
+		return;
+	}
+
+	switch (ds) {
+	case ds_s:
+		map = scanmap_simple;
+		map_length = sizeof(scanmap_simple) / sizeof(int);
+		break;
+	case ds_e:
+		map = scanmap_e0;
+		map_length = sizeof(scanmap_e0) / sizeof(int);
+		break;
+	default:
+		map = NULL;
+		map_length = 0;
+	}
+
+	ds = ds_s;
+	if (scancode == 0xf0) {
+		key_release_flag = 1;
+		return;
+	} else {
+		if (key_release_flag) {
+			type = KEY_RELEASE;
+			key_release_flag = 0;
+			if (is_lock_key(scancode)) {
+				if (!is_locked) {
+					is_locked = 1;
+				} else {
+					is_locked = 0;
+					return;
+				}
+			}
+		} else {
+			if (is_lock_key(scancode) && is_locked)
+				return;
+			type = KEY_PRESS;
+		}
+	}
+
+	if (scancode < 0)
+		return;
+
+	key = map[scancode];
+	if (key != 0)
+		kbd_push_ev(type, key);
+}
+
+static bool is_lock_key(int sc)
+{
+	return ((sc == PL050_CAPS_SCAN_CODE) || (sc == PL050_NUM_SCAN_CODE) ||
+	    (sc == PL050_SCROLL_SCAN_CODE));
+}
+
+void kbd_ctl_set_ind(unsigned mods)
+{
+	(void) mods;
+}
+
+/**
+ * @}
+ */ 
Index: uspace/srv/hid/kbd/generic/kbd.c
===================================================================
--- uspace/srv/hid/kbd/generic/kbd.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/hid/kbd/generic/kbd.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -67,6 +67,6 @@
 static unsigned lock_keys;
 
-bool irc_service = false;
-int irc_phone = -1;
+int cir_service = 0;
+int cir_phone = -1;
 
 #define NUM_LAYOUTS 3
@@ -216,11 +216,12 @@
 	sysarg_t obio;
 	
-	if (((sysinfo_get_value("kbd.cir.fhc", &fhc) == EOK) && (fhc))
-	    || ((sysinfo_get_value("kbd.cir.obio", &obio) == EOK) && (obio)))
-		irc_service = true;
-	
-	if (irc_service) {
-		while (irc_phone < 0)
-			irc_phone = service_connect_blocking(SERVICE_IRC, 0, 0);
+	if ((sysinfo_get_value("kbd.cir.fhc", &fhc) == EOK) && (fhc))
+		cir_service = SERVICE_FHC;
+	else if ((sysinfo_get_value("kbd.cir.obio", &obio) == EOK) && (obio))
+		cir_service = SERVICE_OBIO;
+	
+	if (cir_service) {
+		while (cir_phone < 0)
+			cir_phone = service_connect_blocking(cir_service, 0, 0);
 	}
 	
Index: uspace/srv/hid/kbd/include/kbd.h
===================================================================
--- uspace/srv/hid/kbd/include/kbd.h	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/hid/kbd/include/kbd.h	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -38,8 +38,6 @@
 #define KBD_KBD_H_
 
-#include <bool.h>
-
-extern bool irc_service;
-extern int irc_phone;
+extern int cir_service;
+extern int cir_phone;
 
 extern void kbd_push_scancode(int);
Index: uspace/srv/hid/kbd/port/ns16550.c
===================================================================
--- uspace/srv/hid/kbd/port/ns16550.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/hid/kbd/port/ns16550.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -120,6 +120,6 @@
 	kbd_push_scancode(scan_code);
 	
-	if (irc_service)
-		async_msg_1(irc_phone, IRC_CLEAR_INTERRUPT,
+	if (cir_service)
+		async_msg_1(cir_phone, IRC_CLEAR_INTERRUPT,
 		    IPC_GET_IMETHOD(*call));
 }
Index: uspace/srv/hid/kbd/port/z8530.c
===================================================================
--- uspace/srv/hid/kbd/port/z8530.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/hid/kbd/port/z8530.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -108,6 +108,6 @@
 	kbd_push_scancode(scan_code);
 	
-	if (irc_service)
-		async_msg_1(irc_phone, IRC_CLEAR_INTERRUPT,
+	if (cir_service)
+		async_msg_1(cir_phone, IRC_CLEAR_INTERRUPT,
 		    IPC_GET_IMETHOD(*call));
 }
Index: uspace/srv/hw/bus/cuda_adb/cuda_adb.c
===================================================================
--- uspace/srv/hw/bus/cuda_adb/cuda_adb.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/hw/bus/cuda_adb/cuda_adb.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -367,9 +367,9 @@
 static void cuda_irq_rcv_end(void *buf, size_t *len)
 {
-	uint8_t b;
-	
+	uint8_t data, b;
+
 	b = pio_read_8(&dev->b);
-	pio_read_8(&dev->sr);
-	
+	data = pio_read_8(&dev->sr);
+
 	if ((b & TREQ) == 0) {
 		instance->xstate = cx_receive;
@@ -379,7 +379,7 @@
 		cuda_send_start();
 	}
-	
-	memcpy(buf, instance->rcv_buf, instance->bidx);
-	*len = instance->bidx;
+
+        memcpy(buf, instance->rcv_buf, instance->bidx);
+        *len = instance->bidx;
 	instance->bidx = 0;
 }
Index: uspace/srv/hw/irc/apic/apic.c
===================================================================
--- uspace/srv/hw/irc/apic/apic.c	(revision 8aa2b3bd36816eb9f9e92cc4098498870194aade)
+++ uspace/srv/hw/irc/apic/apic.c	(revision 3a3d4ca595a9beb21ff6843f12c73a08d87978e7)
@@ -56,5 +56,5 @@
 static int apic_enable_irq(sysarg_t irq)
 {
-	/* FIXME: TODO */
+	// FIXME: TODO
 	return ENOTSUP;
 }
@@ -107,5 +107,5 @@
 	
 	async_set_client_connection(apic_connection);
-	service_register(SERVICE_IRC);
+	service_register(SERVICE_APIC);
 	
 	return true;
